
!RBLiteralBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 16:02'!
readWith: anInterpreter
	self flag: 'maybe introduce indirections over the interpreter'.
	^ self value! !

!RBLiteralBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:11'!
value
	^ self binding value! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:05'!
isArgument
	^ self isArgumentBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:05'!
isContext
	^ self isContextBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:05'!
isInstance
	^ self isInstanceBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:06'!
isLiteral
	^ self isLiteralBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSelf
	^ self isSelf! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSuper
	^ self isSuperBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:06'!
isTemp
	^ self isTemporaryBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:06'!
isUndeclared
	^ self isUndeclaredBinding! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/23/2011 16:12'!
selfNodeClass
	^ RBSelfNode! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/23/2011 16:12'!
superNodeClass
	^ RBSuperNode! !

!RBParser methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/30/2011 17:03'!
thisContextNodeClass
	^ RBThisContextNode! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 16:12'!
accept: visitor on: receiver message: aMessage
	self isPrimitive ifTrue: [ 
			^ visitor 
				invokePrimitiveMethod: self 
				on: receiver 
				message: aMessage ].
			
	self isReflective ifTrue: [ 
		^ visitor 
			invokeReflectiveMethod: self
			on: receiver 
			message: aMessage].
		
	^ visitor 
		invokeMethod: self 
		on: receiver 
		message: aMessage! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/9/2011 13:59'!
ast
	^ ASTCache at: self! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 14:14'!
code
	^ self ast! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:44'!
hasPragmaNamed: aSymbol
	^ (self pragmas at: aSymbol) isNil not! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 11:08'!
isPrimitive
	^ self primitive ~= 0! !

!CompiledMethod methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 2/3/2012 15:44'!
isReflective
	^ (self hasPragmaNamed: #reflective:)! !

!RBProgramNodeVisitor methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 19:21'!
acceptSelfNode: aSelfNode
	^ self acceptVariableNode: aSelfNode! !

!RBProgramNodeVisitor methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 19:28'!
acceptSuperNode: aSuperNode
	^ self acceptVariableNode: aSuperNode! !

!RBProgramNodeVisitor methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/8/2011 15:27'!
acceptThisContextNode: aThisContextNode
	^ self acceptVariableNode: aThisContextNode! !

!RBArgumentBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/9/2011 20:00'!
readWith: anInterpreter
	| index | 
	index := self scope node argumentNames indexOf: node name.
	^ anInterpreter readArgumentAt: index node: node! !

!RBTemporaryBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 18:36'!
accept: anInterpeter assign: value
	self flag: ' for now we rely on the temporaries being dicts'.
	^ anInterpeter write: value temporaryAt: -1 named: node name! !

!RBTemporaryBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 18:46'!
readWith: anInterpreter
	self flag: ' for now we rely on the temporaries being dicts'.
	^ anInterpreter readTemporaryAt: -1 named: node name! !

!RBVariableNode class methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 8/30/2011 17:22'!
identifierToken: anIdentifierToken 
	anIdentifierToken value = 'self'
		ifTrue: [ ^ RBSelfNode withToken: anIdentifierToken ].
	anIdentifierToken value = 'thisContext'
		ifTrue: [ ^ RBThisContextNode withToken: anIdentifierToken ].
	anIdentifierToken value = 'super'
		ifTrue: [ ^ RBSuperNode withToken: anIdentifierToken ].
	^ self withToken: anIdentifierToken! !

!RBVariableNode class methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 19:19'!
withToken: anIdentifierToken
	^(self new)
		identifierToken: anIdentifierToken;
		yourself! !

!RBVariableNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:04'!
binding
	^ self variableBinding! !

!RBMethodNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/8/2011 16:19'!
temporaryNames
	^ self body temporaryNames! !

!RBInstanceBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:18'!
accept: aVisitor assign: aValue
	^ aVisitor write: aValue at: index named: name! !

!RBInstanceBinding methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/5/2011 15:22'!
readWith: aVisitor
	^ aVisitor readInstVarAt: index named: name! !

!ContextPart methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/12/2011 14:33'!
returnContext
	^ self methodReturnContext! !

!RBBlockNode methodsFor: '*AST-Interpreter-Extension' stamp: 'CamilloBruni 12/8/2011 15:17'!
temporaryNames
	^ self body temporaryNames! !
